; count, example program for threads v1.0
; This program counts up A to Z with one thread and 0 to 9 with another thread.
; This is a very trivial use for threads, but it demonstrates their use.

.nolist
#include "asm86.h"
#include "ti86asm.inc"
.list

#define STACK_SIZE 50

.org _asm_exec_ram
#define NEED_thread_cancel
#include "threads.asm"

#define mythread	program_end
#define mythread_stack	mythread+sizeof_thread_t+STACK_SIZE
#define bytea		mythread_stack
#define byteb		bytea+1

; main thread
; if 1 is pressed, kills thread1 and thread2
; if 2 is pressed, kills thread2
main:
	ld	hl,mythread		; thread
	ld	de,mythread_code	; code
	ld	bc,mythread_stack	; stack
	call	thread_create
	
	ld	a,'A'
	ld	(bytea),a
_a
	ld	a,(bytea)
	ld	hl,0
	ld	(_curRow),hl
	call	_putc
	inc	a
	cp	'Z'+1
	jr	nz,$+4
	ld	a,'A'
	ld	(bytea),a
	ld	b,10*2
_a1
		push	bc
	call	GET_KEY
		pop	bc
	cp	K_1
	ret	z		; return from program (this also kills mythread)
	cp	K_2
	jr	nz,_anot_2
	ld	hl,mythread
	call	thread_cancel	; cancel "mythread"
_anot_2
	halt
	call	thread_cooperate	; we need to cooperate
	djnz	_a1
	jr	_a

mythread_code:
	ld	a,'0'		; meat of thread
	ld	(byteb),a	;
_b
	ld	a,(byteb)
	ld	hl,1*256+0
	ld	(_curRow),hl
	call	_putc
	inc	a
	cp	'9'+1
	jr	nz,$+4
	ld	a,'0'
	ld	(byteb),a
	ld	b,26*2
_b1
	call	thread_cooperate
	djnz	_b1
	jr	_b

program_end:
.end
